# GenServer

## Features

 - End-to-end encryption
 - Channel
 - Reconnect

## Class

 - GenServer
 - GenClient
 - GenSocket

## Data Flow

## Usage

Server
```dart
import 'package:args/args.dart';

import 'package:gen_server/gen_server.dart';
import 'package:gen_server/gen_socket.dart';

/* Usage & main function here */
Future<GenServer> launchServer() async {
  var gen_server = GenServer(host: '0.0.0.0', port: 8080);
  gen_server.onConnect((GenSocket gen_socket) {
    gen_socket.sendMessage('This is a new message');
    gen_socket.sendMessage('This is a new message - 1');
    gen_socket.sendMessage('This is a new message - 2');
  });
  gen_server.onMessage((GenSocket gen_socket, String data) async {
    gen_server.log('Message: $data');
    await gen_socket.sendMessage('From server::::$data');
  });
  gen_server.onClose((GenSocket gen_socket) {
    print("Socket closed.");
  });
  gen_server.start();
  return gen_server;
}
```

Client
```dart
import 'package:gen_server/gen_client.dart';
import 'package:gen_server/gen_socket.dart';

/* Usage & main function here */
Future<GenClient> launchClient() async {
  // connect to the socket server
  var client = GenClient(host: '127.0.0.1', port: 8080);
  client.onMessage((GenSocket gen_socket, String data) async {
    client.log('Message: $data');
  });
  await client.start();
  return client;
}

void main() async {

  var client = await launchClient();

}

```

## Links

## Author/Contributors

 - Samick - created at 2022.05.17

